#ifdef OPENGL_ES
precision highp float;
#endif

// Uniforms
uniform sampler2D u_diffuseTexture;
uniform float u_specular;
uniform float u_reflect;

// Varyings
varying vec2 o_vUV;
// ovp̌vZꂽ_ƃCg
varying vec3 o_vEye;
varying vec3 o_vLight;

// fog
const float fNear = 0.0;
const float fFar = 32.0;
const vec4 FOG = vec4(0.25, 0.753, 1.0, 1.0);

void main()
{
// diffuse
	vec4 C = texture2D(u_diffuseTexture, o_vUV);
	float A = 0.5;//C.w;

// bump
	vec2 NUV = vec2(o_vUV.x + 0.5, o_vUV. y);
	vec3 N = 2.0 * texture2D(u_diffuseTexture, NUV).xyz - 1.0;
	vec3 L = normalize(o_vLight);
	vec3 R = reflect(normalize(-o_vEye), N);
	float H = dot(N, L) * 0.5 + 0.5;	// n[to[g
	C = C * max(0.0, H) + u_specular * pow(max(0.0, dot(R, L)), 8.0);

// env
	float x = mod(o_vEye.x * 0.01, 0.5);
	x += o_vUV.x;
	x = mod(x, 0.5);

	float y = mod(o_vEye.z * 0.01, 0.5);
	y += o_vUV.y;
	y = mod(y, 0.5);
	vec4 E = texture2D(u_diffuseTexture, vec2(x, y));
	//C *= E;
	C = mix(C, E, u_reflect);

// fog
	float F0 = gl_FragCoord.z / gl_FragCoord.w;
	float F1 = (fFar - F0) / (fFar - fNear);
	F1 = clamp(F1, 0.0, 1.0);
	C = C * F1 + FOG * (1.0 - F1);

	gl_FragColor = vec4(C.xyz, A);
}
