#ifdef OPENGL_ES
precision highp float;
#endif

uniform sampler2D u_diffuseTexture;		// Diffuse map texture

varying vec3 o_vNml;
varying vec2 o_vUV;				// Texture coordinate
varying vec3 o_vEye;

// lightdir
const vec3 vLight = vec3(0.0, 1.0, 0.5);
// fog
const float fNear = 0.0;
const float fFar = 16.0;
const vec4 FOG = vec4(0.1, 0.1, 0.1, 1.0);

void main()
{
	vec3 N = normalize(o_vNml);
	vec3 L = normalize(vLight);
	vec3 E = normalize(o_vEye);

	float F = dot(N, L);
	F = F * 0.5 + 0.5;
	F = F * F;
	F = F + 0.5;

	N = normalize(reflect(-L, N));

	vec4 C = texture2D(u_diffuseTexture, o_vUV);
	float A = C.w;

	//C = C * F;
	//C = C * F + vec4(1.0, 1.0, 1.0, 0.0) * pow(max(dot(N, E), 0.0), 8.0);
	C = C * F + pow(max(dot(N, E), 0.0), 8.0);

// fog
	float F0 = gl_FragCoord.z / gl_FragCoord.w;
	float F1 = (fFar - F0) / (fFar - fNear);
	F1 = clamp(F1, 0.0, 1.0);
	C = C * F1 + FOG * (1.0 - F1);

	gl_FragColor = vec4(C.xyz, A);
}
